﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Controls;
using System.IO;



namespace WpfApplication92
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
      //  ObservableCollection<Person> people = new ObservableCollection<Person>();

        BindingList<Person> people = new BindingList<Person>();
        int? previndx = null;

        string save = string.Empty;
    
        FieldSortDescription [] sortfields = new FieldSortDescription[5];
        int sortcount = 0;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Person p1 = new Person() { Report = false, Name = "joe", Age = 34, Occupation = "programmer", Salary = 43500.00 };
            Person p2 = new Person() { Name = "Bob", Age = 44, Occupation = "Programmer", Salary = 53500.00 };
            Person p3 = new Person() { Name = "Tim", Age = 24, Occupation = "policeman", Salary = 33500.00 };
            Person p4 = new Person() { Name = "Lou", Age = 54, Occupation = "accountant", Salary = 23500.00 };
            Person p5 = new Person() { Name = "Mat", Age = 64, Occupation = "customer service", Salary = 73500.00 };
            Person p6 = new Person() { Name = "Jef", Age = 14, Occupation = "mechanic", Salary = 83500.00 };
            Person p7 = new Person() { Name = "Lee", Age = 74, Occupation = "teacher", Salary = 93500.00 };
            people.Add(p1);
            people.Add(p2);
            people.Add(p3);
            people.Add(p4);
            people.Add(p5);
            people.Add(p6);
            people.Add(p7);
            xgrid1.DataSource = people;
           
             
            

          ///  xgrid1.FieldSettings.CellClickAction = Infragistics.Windows.DataPresenter.CellClickAction.EnterEditModeIfAllowed;
            xgrid1.CellActivated += new EventHandler<Infragistics.Windows.DataPresenter.Events.CellActivatedEventArgs>(xgrid1_CellActivated);
            xgrid1.FieldLayouts[0].Fields["Report"].Settings.CellClickAction = Infragistics.Windows.DataPresenter.CellClickAction.SelectCell;
            xgrid1.FieldLayouts[0].Fields["Report"].Settings.AllowEdit = false;
            xgrid1.PreviewMouseMove += new MouseEventHandler(xgrid1_PreviewMouseMove);
            xgrid1.PreviewMouseLeftButtonDown += new MouseButtonEventHandler(xgrid1_PreviewMouseLeftButtonDown);
          
       
         

        }

        void xgrid1_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //throw new NotImplementedException();
            DependencyObject source = e.OriginalSource as DependencyObject;


            if (source == null) return;


            CellValuePresenter cvp = Infragistics.Windows.Utilities.GetAncestorFromType(source, typeof(CellValuePresenter), true) as CellValuePresenter;


            if (cvp == null)
            {
                previndx = null;
                return;
            }

            //if (e.LeftButton == MouseButtonState.Released)
            //    return;

            if (cvp.Field.Name == "Report")
            {
                if (previndx != null)
                {
                    if (cvp.Record.Index != previndx)
                    {
                     //   cvp.IsActive = true;
                        DataRecord dr = (DataRecord)cvp.Record;
                        dr.Cells["Report"].IsActive = true;
                    //    xgrid1.ActiveCell = dr.Cells["Report"];

                    }
                    previndx = cvp.Record.Index;

                }
                else
                {
                    previndx = cvp.Record.Index;
                  //  cvp.IsActive = true;
                    DataRecord dr = (DataRecord)cvp.Record;
                    dr.Cells["Report"].IsActive = true;
                 //   xgrid1.ActiveCell = dr.Cells["Report"];
                }
            }
            else previndx = null;

        }

        void xgrid1_PreviewMouseMove(object sender, MouseEventArgs e)
        {
            //throw new NotImplementedException();
            DependencyObject source = e.OriginalSource as DependencyObject;


            if (source == null) return;


            CellValuePresenter cvp = Infragistics.Windows.Utilities.GetAncestorFromType(source, typeof(CellValuePresenter), true) as CellValuePresenter;


            if (cvp == null)
            {
                previndx = null;
                return;
            }

            if (e.LeftButton == MouseButtonState.Released)
                return;

             if (cvp.Field.Name == "Report")
             {
                 if (previndx != null)
                 {
                     if (cvp.Record.Index != previndx)
                     {
                     //    cvp.IsActive = true;
                         DataRecord dr = (DataRecord)cvp.Record;
                         dr.Cells["Report"].IsActive = true;
                         xgrid1.ActiveCell = dr.Cells["Report"];
                        
                     }
                     previndx = cvp.Record.Index;

                 }
                 else
                 {
                     previndx = cvp.Record.Index; 
                 //    cvp.IsActive = true;
                     DataRecord dr = (DataRecord)cvp.Record;
                     dr.Cells["Report"].IsActive = true;
                     xgrid1.ActiveCell = dr.Cells["Report"];
                 }
             }
             else previndx = null;
           // cvp.IsActive = true;


            //cvp.IsSelected = true;


            //cvp.Record.IsSelected = true;
            //     cvp.Value = ! ((bool)cvp.Value);
              


            // xamDataGrid1.ExecuteCommand(DataPresenterCommands.StartEditMode);


        }

        void xgrid1_CellActivated(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatedEventArgs e)
        {
            //throw new NotImplementedException();
            
            if (e.Cell.Field.Name == "Report")
            {

                e.Cell.Value = !((bool)e.Cell.Value);
             //   xgrid1.ExecuteCommand(DataPresenterCommands.ToggleActiveRecordSelectionState);
            }
                
        }

        
 

       

        private void clearfitlers_Click(object sender, RoutedEventArgs e)
        {
            xgrid1.FieldLayouts[0].RecordFilters.Clear(); 
        }

        private void savecustom_Click(object sender, RoutedEventArgs e)
        {
          //  xgrid1.
              save = xgrid1.SaveCustomizations();

            StreamWriter sw = new StreamWriter("Save.xml");
            sw.Write(save);
            sw.Close();
            MessageBox.Show(save);
        }

        private void LoadCustom_Click(object sender, RoutedEventArgs e)
        {
            //StreamReader sr = new StreamReader("new.xml");
            //save = sr.ReadToEnd();
            //load = true;
            xgrid1.LoadCustomizations(save);

          //  xgri .LoadCustomizations(save);
        }
    }
}
